package com.svv.util;
import com.svv.cbr.cases.TrafficSituationCase;

import java.io.*;
import java.util.ArrayList;

/**
 * Store a case in the case base xml file
 * @author yvind, Fredrick
 *
 */
public class AddToXml {
	TrafficSituationCase trafficSituationCase;
	public AddToXml(TrafficSituationCase trafficSituationCase) {
		this.trafficSituationCase = trafficSituationCase;
	}
	/**
	 * Store a case to the case base
	 */
	public void saveInstanceToXML() 
	{
	   try{
    	   StringBuilder caseBaseString = new StringBuilder();
    	   FileReader fstream = new FileReader(Config.CB_INSTANCES);
  		 	BufferedReader br = new BufferedReader(fstream);
  			String strLine;
  			boolean caseHasBeenAddedBefore = caseHasBeenAddedBefore();
			int caseNumber = 0; 
  			while ((strLine = br.readLine()) != null) 
  			{
  				if(!(strLine.equals("</knowledge_base>"))) 
  				{
  					caseBaseString.append(strLine + "\r\n");
  				} 
  				else 
  				{
  					
					if(caseHasBeenAddedBefore) 
					{
						caseNumber = findCaseNumber();
						if(caseNumber == -1) 
						{
							System.out.println("Error finding case number!");
							break;
						}
						caseBaseString.append("\n<simple_instance>");
						caseBaseString.append("\n<name>AddedCase_" + (caseNumber + 1) + "</name>" +
								"\n<type>TraficSituation</type>" + 
								"\n<own_slot_value>");
					} 
					else 
					{
						caseBaseString.append("\n<simple_instance>");
						caseBaseString.append("\n<name>AddedCase_1</name>" +
								"\n<type>TraficSituation</type>" + 
								"\n<own_slot_value>");
					}						
					
					caseBaseString.append("\n<slot_reference>ProposedTransitionTime</slot_reference>");
					caseBaseString.append("\n<value value_type=\"string\">" + trafficSituationCase.getSolution() + "</value>");
					caseBaseString.append("\n</own_slot_value>\n<own_slot_value>");
					
					caseBaseString.append("\n<slot_reference>PedestrianType</slot_reference>");
					caseBaseString.append("\n<value value_type=\"string\">" + trafficSituationCase.getPedestrianType() + "</value>");
					caseBaseString.append("\n</own_slot_value>\n<own_slot_value>");
					
					caseBaseString.append("\n<slot_reference>TimeWaited</slot_reference>");
					caseBaseString.append("\n<value value_type=\"string\">"+ trafficSituationCase.getTimeWaited() + "</value>");
					caseBaseString.append("\n</own_slot_value>\n<own_slot_value>");
					
					caseBaseString.append("\n<slot_reference>PositiveIntentions</slot_reference>");
					caseBaseString.append("\n<value value_type=\"string\">"+ trafficSituationCase.getPositiveIntentions() + "</value>");
					caseBaseString.append("\n</own_slot_value>\n<own_slot_value>");
	
					caseBaseString.append("\n<slot_reference>SpeedOfDetectedVehicle</slot_reference>");
					caseBaseString.append("\n<value value_type=\"string\">" + trafficSituationCase.getSpeedOfDetectedVehicle() + "</value>");
					caseBaseString.append("\n</own_slot_value>\n<own_slot_value>");
	
					caseBaseString.append("\n<slot_reference>VehicleDetected</slot_reference>");
					caseBaseString.append("\n<value value_type=\"boolean\">" + trafficSituationCase.getVehicleDetected() + "</value>");
					caseBaseString.append("\n</own_slot_value>\n<own_slot_value>");
	
					caseBaseString.append("\n<slot_reference>TrafficFlow</slot_reference>");
					caseBaseString.append("\n<value value_type=\"string\">" + trafficSituationCase.getTrafficFlow() + "</value>");
					caseBaseString.append("\n</own_slot_value>");
					caseBaseString.append("\n</simple_instance>");
	
					caseBaseString.append("\n</knowledge_base>");
   				}
   			}
   			br.close();
   		    
   			writeToFile(Config.CB_INSTANCES, caseBaseString);
     		
   			StringBuilder caseBaseString2 = new StringBuilder();
     	    FileReader fstream2 = new FileReader(Config.CB_MYCBR_INSTANCES);
   		 	BufferedReader br2 = new BufferedReader(fstream2);
   			String strLine2;
   			while ((strLine2 = br2.readLine()) != null) 
   			{
   				if(!(strLine2.equals("</Instances_for_Class>"))) 
  				{
  					caseBaseString2.append(strLine2 + "\r\n");
  				} 
   				else 
   				{
  					if(caseHasBeenAddedBefore) 
					{
						if(caseNumber == -1) 
						{
							System.out.println("Error finding case number!");
							break;
						}
						caseBaseString2.append("<Instance model_instname=\"" + (caseNumber + 1) + "\">");

					} 
					else 
					{
						caseBaseString2.append("<Instance model_instname=\"AddedCase_1\">");
					}	
  					caseBaseString2.append("\n<slotvalue slot=\"TrafficFlow\" value=\"" + trafficSituationCase.getTrafficFlow() + "\" />");
  					caseBaseString2.append("\n<slotvalue slot=\"VehicleDetected\" value=\"" + trafficSituationCase.getVehicleDetected() + "\" />");
  					caseBaseString2.append("\n<slotvalue slot=\"ProposedTransitionTime\" value=\"" + trafficSituationCase.getSolution() + "\" />");
  					caseBaseString2.append("\n<slotvalue slot=\"SpeedOfDetectedVehicle\" value=\"" + trafficSituationCase.getSpeedOfDetectedVehicle() + "\" />");
  					caseBaseString2.append("\n<slotvalue slot=\"PedestrianType\" value=\"" + trafficSituationCase.getPedestrianType() + "\" />");
  					caseBaseString2.append("\n<slotvalue slot=\"PositiveIntentions\" value=\"" + trafficSituationCase.getPositiveIntentions() + "\" />");
  					caseBaseString2.append("\n<slotvalue slot=\"TimeWaited\" value=\"" + trafficSituationCase.getTimeWaited() + "\" />");
  					caseBaseString2.append("\n</Instance>\n</Instances_for_Class>");
  				}
   				
   			}
   			writeToFile(Config.CB_MYCBR_INSTANCES, caseBaseString2);
	   }catch (Exception e){
		   System.err.println("Input/output error: " + e.getMessage());
	   }

	}
	
	private void writeToFile(String path, StringBuilder newCaseBase) {
		try {
			FileWriter outStream = new FileWriter(path);
			BufferedWriter bw = new BufferedWriter(outStream, 64*1024);
			bw.write(newCaseBase.toString());
			bw.close();
		} catch (Exception e) {
			System.out.println("Could not write to file: AddToXml.java");
		}
		
	}
	private int findCaseNumber() 
	{
		try {
			FileReader fstream = new FileReader(Config.CB_INSTANCES);
			BufferedReader br = new BufferedReader(fstream);	
			String strLine;
	    	ArrayList<Integer> caseNumbers = new ArrayList<Integer>() ;
			while ((strLine = br.readLine()) != null) 
			{
				if(strLine.contains("AddedCase_"))
				{
					caseNumbers.add((Integer.parseInt(strLine.split("<|>|_")[3])));
				}
			}
			return caseNumbers.get(caseNumbers.size()-1);
			
		} catch (Exception e) {
			System.out.println("Error finding case number" + e.getMessage());
		}
		
		return -1;
	}
	private boolean caseHasBeenAddedBefore() 
	{
		try {
			FileReader fstream = new FileReader(Config.CB_INSTANCES);
			BufferedReader br = new BufferedReader(fstream);	
			String strLine;
			while ((strLine = br.readLine()) != null) 
			{
	 		   if(strLine.contains("AddedCase_")) 
	 		   {
	 			   br.close();
	 			   return true;
	 		   }
			}
			br.close();
			return false;
		}catch (Exception e) {
			System.out.println("I/O exception:" + e.getMessage());
		}
		return false;
	}

}
