package CBR;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import cases.*;

public class Cbr{
	private TrafficSituation trafficSituation;
	
	public Cbr()
	{
		try
		{
			trafficSituation = new TrafficSituation();
		}catch(Exception e){
			System.out.println("CBR ERROR1: " + e.getMessage());
		}
	}
	
	public String getSolution(TrafficSituationCase trafficCase)
	{
		try
		{
			return trafficSituation.getProposedTransitionTime(trafficCase);
		}catch(Exception e){
			System.out.println("CBR ERROR2: " + e.getMessage());
		}
		return null;
	}
	
	public ArrayList<TrafficSituationCase> getMatchingCases(TrafficSituationCase trafficCase)
	{
		try
		{
			return trafficSituation.getCasesMatchingQuery(trafficCase);
			
		}catch(Exception e){
			System.out.println("CBR ERROR2: " + e.getMessage());
		}
		return null;
	}
	
	public String getSolutionCase(TrafficSituationCase trafficCase)
	{
		try
		{
			ArrayList<TrafficSituationCase> trafficSituationCases = trafficSituation.getCasesMatchingQuery(trafficCase);
			return findBestTrafficSituationCase(trafficSituationCases);
			
		}catch(Exception e){
			System.out.println("CBR ERROR2: " + e.getMessage());
		}
		return null;
	}
	
	public static String findBestTrafficSituationCase(ArrayList<TrafficSituationCase> trafficSituationCases)
	{
		HashMap<String, Integer> solutionList = new HashMap<String, Integer>();
		for(TrafficSituationCase trafficCase : trafficSituationCases)
		{
			String solution = trafficCase.getSolutionProposedTransitionTime();
			if(!solutionList.containsKey(solution))
			{
				solutionList.put(solution, 1);
			}
			else
			{
				int value = (int)solutionList.get(solution) + 1;
				solutionList.put(solution, value);
			}
		}
		return getMaxValue(solutionList);
	}
	
	private static String getMaxValue(HashMap<String, Integer> solutionList)
	{
		int maxValue = 0;
		String solution = "";
		for(Map.Entry<String, Integer> entry: solutionList.entrySet())
		{
			if(maxValue < entry.getValue())
			{
				maxValue = entry.getValue();
				solution = entry.getKey();
			}
		}
		return solution;
	}
}
