package CBR;

import java.text.DecimalFormat;
import java.util.HashMap;


import cases.TrafficSituationCase;

public class CbrCore {
	
	private Cbr cbr;
	private final int RUNS = 1;
	
	private final boolean testCaseBase = false;

	public CbrCore()
	{
		cbr = new Cbr();
		try
		{
			TrafficSituation ts = new TrafficSituation();
			int accumulatedCorrectlyClassifiedCases = 0;
			double averageSimilarity = 0.0;
			int CBSize = 0;
			
			double accumulatedCorrectlyClassifiedCasesWithSimilairty = 0;
			
			for(int i = 0; i < RUNS; i++) 
			{
				HashMap<String,String> validationResults;
				if(testCaseBase)
				{
					validationResults= ts.testCases();
				}
				else
				{
					validationResults= ts.leaveOneOutValidation();
				}
				
				if(i == 0) {
					
					averageSimilarity = Double.parseDouble(validationResults.get("averageSimilarity"));
				}
				try
				{
					accumulatedCorrectlyClassifiedCases += Integer.parseInt(validationResults.get("correctlyClassifiedCases"));
					accumulatedCorrectlyClassifiedCasesWithSimilairty += Double.parseDouble(validationResults.get("correctlyClassifiedCasesWithSimilairty"));
					CBSize =  Integer.parseInt(validationResults.get("CBSize"));
				} catch (Exception e)
				{
					System.out.println("Could not parse validation results!");
				}
			}
			DecimalFormat df = new DecimalFormat("#.#");
			System.out.println("Average similarity: " + averageSimilarity);
			System.out.println("Number of correctly classified cases: " + accumulatedCorrectlyClassifiedCases/RUNS + " out of " + CBSize + 
					" (" + df.format((((double)accumulatedCorrectlyClassifiedCases/(double)RUNS)/(double)CBSize)*100.0) + "%)");
			System.out.println("Number of correctly classified cases with similairty between solution: " + accumulatedCorrectlyClassifiedCasesWithSimilairty/RUNS + " out of " + CBSize +
					" (" + df.format(((accumulatedCorrectlyClassifiedCasesWithSimilairty/RUNS)/CBSize)*100.0) + "%)");
		}catch(Exception e){
			System.out.println(e.getMessage());
		}
	}
	
	
	public void getSimulatedCases() throws Exception
	{
		
	
//		TrafficSituationCase queryCase = new TrafficSituationCase(trafficFlow, vehicleDetected, speedOfDetectedVehicle, positiveIntentions, timeWaited, pedestrianType)
//		ArrayList<TrafficSituationCase> trafficCases = TrafficSituation.getCasesMatchingQuery(queryCase);
//		return trafficCases;
	}
	
	public void checkTrafficSituation(TrafficSituationCase trafficCase)
	{
		System.out.println(cbr.getSolution(trafficCase));
	}
	
	public static void main(String[] args)
	{
		new CbrCore();
	}
}
