package EA;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Random;

public class SelectionStrategies {
	
	private int numberOfParents;
	
	public SelectionStrategies(int numberOfParents)
	{
		this.numberOfParents = numberOfParents;
	}
	
	public ArrayList<Unit> full_replacement(ArrayList<Unit> adults, ArrayList<Unit> children)
	{
		return children;
	}
	
	private boolean wheel(double percentFitness)
	{
		Random r = new Random();
		if((double)(r.nextInt(100)/100.0) < percentFitness)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public ArrayList<Unit> fitnessProportionate(ArrayList<Unit> adults)
	{
		double sumFitness = 0;
		for(Unit adult : adults)
		{
			sumFitness += adult.getFitness();
		}
		
		int parentsLeftToChoose = numberOfParents;
		ArrayList<Unit> parents = new ArrayList<Unit>();
		while(parentsLeftToChoose > 0)
		{
			Collections.shuffle(Arrays.asList(parents));
			for(Unit adult : adults)
			{
				boolean chooseAdult = wheel(adult.getFitness()/sumFitness);
				if(chooseAdult)
				{
					parentsLeftToChoose--;
					parents.add(adult);
					if(parentsLeftToChoose == 0)
					{
						break;
					}
				}
			}
		}
		return parents;
	}
}
