package cases;

public class TrafficSituationCase {

	private String trafficFlow, speedOfDetectedVehicle, positiveIntentions, timeWaited, pedestrianType, solutionProposedTransitionTime;
	private double similarity;
	private boolean vehicleDetected;
	
	public TrafficSituationCase(String trafficFlow, boolean vehicleDetected, String speedOfDetectedVehicle, 
			String positiveIntentions, String timeWaited, String pedestrianType) throws NullPointerException
	{
		if(trafficFlow == null || speedOfDetectedVehicle == null || positiveIntentions == null || timeWaited == null || pedestrianType == null)
		{
			throw new NullPointerException("TrafficSituationCase error: Some of the features is NULL");
		}
		else
		{
			this.trafficFlow = trafficFlow;
			this.vehicleDetected = vehicleDetected;
			this.speedOfDetectedVehicle = speedOfDetectedVehicle;
			this.positiveIntentions = positiveIntentions;
			this.timeWaited = timeWaited;
			this.pedestrianType = pedestrianType;
		}
	}
	
	public String getTrafficFlow()
	{
		return trafficFlow;
	}
	
	public boolean getVehicleDetected()
	{
		return vehicleDetected;
	}
	
	public String getSpeedOfDetectedVehicle()
	{
		return speedOfDetectedVehicle;
	}
	
	
	public String getPositiveIntentions()
	{
		return positiveIntentions;
	}
	
	public String getTimeWaited()
	{
		return timeWaited;
	}

	public String getPedestrianType()
	{
		return pedestrianType;
	}
	
	public void setSimilarity(double similarity)
	{
		this.similarity = similarity;
	}
	
	public double getSimilarity()
	{
		return similarity;
	}
	
	public void setSolutionProposedTransitionTime(String solutionProposedTransitionTime)
	{
		this.solutionProposedTransitionTime = solutionProposedTransitionTime;
	}
	
	public String getSolutionProposedTransitionTime()
	{
		return solutionProposedTransitionTime;
	}
	
	@Override
	public String toString()
	{
		return trafficFlow +" "+vehicleDetected + " " + speedOfDetectedVehicle +" " + positiveIntentions + " "
				+ timeWaited + " " + pedestrianType;
	}
}
