package examples;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import cases.TrafficSituationCase;

import de.dfki.mycbr.core.DefaultCaseBase;
import de.dfki.mycbr.core.ICaseBase;
import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.casebase.Case;
import de.dfki.mycbr.core.casebase.Instance;
import de.dfki.mycbr.core.model.Concept;
import de.dfki.mycbr.core.model.FloatDesc;
import de.dfki.mycbr.core.model.IntegerDesc;
import de.dfki.mycbr.core.model.StringDesc;
import de.dfki.mycbr.core.model.SymbolDesc;
import de.dfki.mycbr.core.retrieval.Retrieval;
import de.dfki.mycbr.core.retrieval.RetrievalEngine;
import de.dfki.mycbr.core.retrieval.SequentialRetrieval;
import de.dfki.mycbr.core.similarity.FloatFct;
import de.dfki.mycbr.core.similarity.IntegerFct;
import de.dfki.mycbr.core.similarity.Similarity;
import de.dfki.mycbr.core.similarity.config.NumberConfig;
import de.dfki.mycbr.io.MyCBRImporter;
import de.dfki.mycbr.io.XMLImporter;
import de.dfki.mycbr.util.Pair;

public class TrafficSituation{
	private IntegerDesc pedestriansWithIntention,solutionChangePriority;
	private FloatDesc vehiclesPerTimeUnit, solutionProposedTransitionTime;
	private Concept trafficSituation;
	private Project p;
	
	public TrafficSituation() throws Exception
	{
		p = new Project("C:\\Users\\Fredrick\\Documents\\Fredrick\\dbmycbr\\traffic_CBR_SMF.XML");
		new MyCBRImporter(p);
		
		//After the importation there is created two case bases. With two case bases the similarity method wont work.
		p.deleteCaseBase("CaseBase1");
		
		HashMap<String, Concept> hm = p.getAllSubConcepts();
		trafficSituation = hm.get("Traffic");
		
		
		pedestriansWithIntention = (IntegerDesc)trafficSituation.getAttributeDesc("pedestriansWithIntention");
		vehiclesPerTimeUnit = (FloatDesc)trafficSituation.getAttributeDesc("vehiclesPerTimeUnit");
		solutionProposedTransitionTime = (FloatDesc)trafficSituation.getAttributeDesc("solutionProposedTransitionTime");
		solutionChangePriority = (IntegerDesc)trafficSituation.getAttributeDesc("solutionChangePriority");
	}
	
//	public ArrayList<TrafficSituationCase> getRetrivedCases(TrafficSituationCase query) throws Exception
//	{
//		Retrieval r = new Retrieval(trafficSituation);
//		Instance q = r.getQuery();
//		q.addAttribute(pedestriansWithIntention.getName(), query.getPedestriansWithIntention());
//		q.addAttribute(vehiclesPerTimeUnit.getName(), query.getVehiclesPerTimeUnit());
//		r.start();
//		
//		ArrayList<TrafficSituationCase> tscArray = new ArrayList<TrafficSituationCase>();
//		for (Map.Entry<Case, Similarity> entry: r.entrySet()) {
//			Case c = entry.getKey();
//			TrafficSituationCase trafficCase = new TrafficSituationCase(c.getID(), 
//					Float.parseFloat(c.getAttForDesc(vehiclesPerTimeUnit).getValueAsString()),
//					Integer.parseInt(c.getAttForDesc(pedestriansWithIntention).getValueAsString()),
//					Float.parseFloat(c.getAttForDesc(solutionProposedTransitionTime).getValueAsString()),
//					Integer.parseInt(c.getAttForDesc(solutionChangePriority).getValueAsString()));
//			trafficCase.setSimilarity(entry.getValue().getValue());
//			
//			tscArray.add(trafficCase);
//		}
//		return tscArray;
//	}
}