/*
 * DecisionMaker.cpp
 *
 *  Created on: May 9, 2011
 *      Author: johnsverre
 */

#include "DecisionMaker.h"
#include "User.h"
#include <iostream>

DecisionMaker::DecisionMaker() {
	// TODO Auto-generated constructor stub

}

DecisionMaker::~DecisionMaker() {
	// TODO Auto-generated destructor stub
}


/* if true - user wants to go through door */
bool DecisionMaker::evaluateUser(const User& u){
	if(!u.countFeatureSets() > 0) return false;
	FeatureSet fs = u.getLatestFeatureSet();
	if(fs.used) return false;
	fs.used = true; // flag the used feature sets
	double proximityThreshold = 20000;
	double proximityThresholdMoving = 20000;
	double angleInwards = 4;
	double speedThreshold = 0.8;

	if(fs.timestamp == 0) return false; // invalid feature set

	if(fs.distance > proximityThresholdMoving){ // proximity check
		return false;
	}

	// user is now within the specified proximityThreshold

	if(fs.heading >=0 && fs.heading < angleInwards && fs.speed > speedThreshold){
		cout << "coming towards door within proximity threshold" << endl;
		return true;
	}

	if(fs.heading >=0 && fs.heading >= angleInwards && fs.speed > speedThreshold){
		return false;
	}

	// user is lingering within the proximityThreshold
	if(fs.body_alignment < angleInwards && fs.distance < proximityThreshold){
		cout << "oriented towards door within proximity threshold" << endl;
		return true;
	}else{
		return false;
	}

	return false;

}
