/*
 * UserHandler.h
 *
 *  Created on: Apr 22, 2011
 *      Author: johnsverre
 */

#ifndef USERHANDLER_H_
#define USERHANDLER_H_

#include <vector>
#include <XnCppWrapper.h>
#include "User.h"
#include "DecisionMaker.h"

#include <time.h>

using namespace xn;

class UserHandler {
public:
	UserHandler();
	virtual ~UserHandler();
	void runUserCalculations();
	void addUser(User u);
	void updateUserPoints();
	User getUser(int index);
	void removeUser(XnUserID userid);
	int getUserCount() const;
	void inferUserIntentions(XnUserID &openingDoor);
	int getAllUsersIntentions() const;
private:
	vector<User> users;
	DecisionMaker *decisionMaker;
	time_t lastOpenRequest;
};

#endif /* USERHANDLER_H_ */
