/*
 * PointFrame.h
 *
 *  Created on: Apr 18, 2011
 *      Author: johnsverre
 */

#ifndef USERPOINTS_H_
#define USERPOINTS_H_

#include <XnCppWrapper.h>
#include <string>

using namespace xn;
using namespace std;

class UserPoints{
public:
	UserPoints();
	UserPoints(UserGenerator &ug, XnUserID user);
	XnPoint3D getLShoulder();
	XnPoint3D getRShoulder();
	XnPoint3D getLHip();
	XnPoint3D getRHip();
	XnPoint3D getTorso();
	XnPoint3D *getJoints();
	XnUInt64 getTimestamp();

	void setLShoulder(XnPoint3D ls);
	void setRShoulder(XnPoint3D rs);
	void setLHip(XnPoint3D lh);
	void setRHip(XnPoint3D rh);
	void setTorso(XnPoint3D t);

	void setJoints(XnPoint3D *joints);

	float calcShoulderAngle() const;
	float calcHipAngle() const;
	int calcSensorDistance() const;
	XnPoint3D calcMiddlePoint(XnPoint3D &p1, XnPoint3D &p2) const;
	bool isValid() const;
	string toString() const;
	virtual ~UserPoints();
private:
	XnUserID user;
	XnUInt64 timestamp;
	XnPoint3D door;
	XnPoint3D joints[5];
	bool angleDeg;
	float calcPointAngle(XnPoint3D p1, XnPoint3D p2) const;
};

#endif /* USERPOINTS_H_ */
