package com.ntnu.core;

import java.util.ArrayList;
import java.util.Hashtable;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.event.EventConstants;
import org.osgi.service.event.EventHandler;
import org.npra.ven.VenSend;

public class Activator implements BundleActivator {
	private final boolean TIME_BASED_TRAFFIC_LIGHT = true;
//	public static final String PATH = 
//			"C:\\Users\\Fredrick\\Dropbox\\Masteroppgave\\Planlegging\\Case base\\pedestrians1530-1630.txt";
	//public static final String PATH = 
		//	"C:\\Users\\Fredrick\\Dropbox\\Masteroppgave\\Planlegging\\Case base\\pedestrians1530-1630_20%p.txt";
	public static final String PATH = 
			"C:\\Users\\Fredrick\\Dropbox\\Masteroppgave\\Planlegging\\Case base\\pedestrians1230-1330_3.txt";
//	public static final String PATH = 
//	"C:\\Users\\Fredrick\\Dropbox\\Masteroppgave\\Planlegging\\Case base\\pedestrians1230-1330_2.txt";

	
	public static BundleContext bc = null;
	private double intentions = 0;
	private TrafficLightEventHandler trafficLightEventHandler;
	private TimeBasedTrafficLight timeBasedTrafficLight = null;
	private ArrayList<Long> waitingPedestrianTimeStamp;
	
	public void start(BundleContext context) throws Exception {
		Activator.bc = context;
		SendPedestrians sendPedestrians = new SendPedestrians();
		waitingPedestrianTimeStamp = new ArrayList<>();
		new Thread(sendPedestrians).start();
		
		trafficLightEventHandler = new TrafficLightEventHandler(this);
		Hashtable<String,String> properties = new Hashtable<String,String>();
		properties.put( EventConstants.EVENT_TOPIC, "org/npra/ven/*");
		bc.registerService(EventHandler.class.getName(), trafficLightEventHandler, properties);
		if(TIME_BASED_TRAFFIC_LIGHT)
		{
			timeBasedTrafficLight = new TimeBasedTrafficLight();
		}
	}
	
	private double sumWaitingPedestrians = 0;
	
	public synchronized void calcAvgWaitingTime()
	{
		sumWaitingPedestrians = 0;
		double currentTime = System.currentTimeMillis();
		for(long l : waitingPedestrianTimeStamp)
		{
			sumWaitingPedestrians +=  currentTime - l;
		}
		sumWaitingPedestrians = sumWaitingPedestrians/1000.0;
	}
	
	public synchronized void clearIntention()
	{
		sumWaitingPedestrians = sumWaitingPedestrians/waitingPedestrianTimeStamp.size();
		waitingPedestrianTimeStamp.clear();
		Util.writeToFile("C:\\Users\\Fredrick\\Desktop\\all_solutions_from_senario.txt", "Intentions: "+ 
		intentions+"\r\nAvg time waited "+ sumWaitingPedestrians +"\r\n\r\n");
		intentions = 0;
	}
  
	public void stop(BundleContext context) throws Exception {
	}
	
	private class SendPedestrians implements Runnable{

		private long startTime;
		private ArrayList<String[]> pedestrians;
		
		public SendPedestrians()
		{
			startTime = System.currentTimeMillis();
			pedestrians = ReadPedestrianData.readPedestrianData(PATH, startTime);
		}
		
		@Override
		public synchronized void run() {
			ServiceReference reference = Activator.bc.getServiceReference(VenSend.class.getName());
			VenSend service = (VenSend)Activator.bc.getService(reference);	
			while(!pedestrians.isEmpty())
			{
				for (int i = 0; i < pedestrians.size(); i++)
				{
					long pedestrianAtTime = Long.parseLong(pedestrians.get(i)[0]);
					if(pedestrianAtTime < System.currentTimeMillis())
					{
						//Send pedestrian type
						ArrayList<String> pedestrianType = new ArrayList<>();
						pedestrianType.add((String)pedestrians.get(i)[1]);
						service.sendMessage("KINECT","TYPE", pedestrianType);
						
						//Count intention and send
						intentions++;
	                	ArrayList<Double> intentionList = new ArrayList<Double>();
		    			intentionList.add((Double)intentions);
						service.sendMessage("KINECT","INTENTION", intentionList);
						waitingPedestrianTimeStamp.add(System.currentTimeMillis());
						
						//if time based traffic light is activated
						if(TIME_BASED_TRAFFIC_LIGHT)
						{
							timeBasedTrafficLight.changeTrafficLight();
						}
						
						//Remove pedestrian detected
						pedestrians.remove(i);
						break;
					}
				}
				try
				{
					Thread.sleep(100);
				}catch(Exception e){System.out.println("SendPedestrians sleep error: "+e.getMessage());}
			}
		}
	}
}