package com.ntnu.core;
import java.io.*;
import java.util.ArrayList;

public class ReadPedestrianData {
	public static final  ArrayList<String[]> readPedestrianData(String path, long startTime)
	{
		//A hash map containing a key which is the time the pedestrians enters, and a value that is how many pedestrians enter
		ArrayList<String[]> pedestriansAtTimestamp = new ArrayList<>();
		try
		{
			FileReader fstream = new FileReader(path);
			BufferedReader br = new BufferedReader(fstream);	
			String strLine;
			String typeOfPedestrian = "";
			while ((strLine = br.readLine()) != null) 
			{
				String [] splittedLine = strLine.split("\t");
				typeOfPedestrian = splittedLine[1];
				pedestriansAtTimestamp.add(new String[] {getTimeToSendPedestrian(splittedLine[0], startTime)+"", typeOfPedestrian});
			}
			br.close();
		} catch (Exception e)
		{
			System.out.println("Could not read pedestrian data from file!");
		}
		return pedestriansAtTimestamp;
		
	}
	
	private static long getTimeToSendPedestrian(String str, long startTime) 
	{
		String[] splittedString = str.split(":");
		
		int hours = Integer.parseInt(splittedString[0]);
		int minutes = Integer.parseInt(splittedString[1]);
		int seconds = Integer.parseInt(splittedString[2]);
		
		long numberOfMilliseconds = ((hours * 3600) + (minutes * 60) + seconds) * 1000;

		return startTime + numberOfMilliseconds;
	}
}
