package com.ntnu.core;

import java.util.ArrayList;

import org.npra.ven.VenSend;
import org.osgi.framework.ServiceReference;

public class TimeBasedTrafficLight {
	private final double GREEN_PEDESTRIAN_TIME_SEC = 8.25, YELLOW_PEDESTRIAN_TIME_SEC = 3, RED_PEDESTRIAN_TIME_SEC = 30;
	private long timeWaited = -1;
	
	public TimeBasedTrafficLight()
	{
		TrafficLight trafficLight = new TrafficLight();
		new Thread(trafficLight).start();
	}
	
	public void changeTrafficLight()
	{
		if(timeWaited == -1)
		{
			timeWaited = System.currentTimeMillis();
		}
	}
	
	private class TrafficLight implements Runnable
	{

		@Override
		public synchronized void run() {
			try
			{
				while(true)
				{
					changeColorSimulator("RED");
					if(timeWaited != -1)
					{
						long timePassed = System.currentTimeMillis()-timeWaited;
						if(timePassed > (RED_PEDESTRIAN_TIME_SEC * 1000))
						{
							changeGreen();
						}
					}
					Thread.sleep(500);
				}
			}catch(Exception e){
				System.out.println("TimeBasedTrafficLight error: "+e.getMessage());
			}

		}
		
		public void changeGreen()
		{
			try
			{
				//Change amber
				long startTime = System.currentTimeMillis();
				long timePassed = System.currentTimeMillis() - startTime;
				while(timePassed < YELLOW_PEDESTRIAN_TIME_SEC * 1000)
				{
					timePassed = System.currentTimeMillis() - startTime;
					changeColorSimulator("AMBER");
					Thread.sleep(1000);
					
				}
				
				//Change green
				startTime = System.currentTimeMillis();
				timePassed = System.currentTimeMillis() - startTime;
				while(timePassed < GREEN_PEDESTRIAN_TIME_SEC * 1000)
				{
					timePassed = System.currentTimeMillis() - startTime;
					changeColorSimulator("GREEN");
					Thread.sleep(1000);
				}
				timeWaited = -1;
				//Change amber
				startTime = System.currentTimeMillis();
				timePassed = System.currentTimeMillis() - startTime;
				while(timePassed < YELLOW_PEDESTRIAN_TIME_SEC * 1000)
				{
					timePassed = System.currentTimeMillis() - startTime;
					changeColorSimulator("AMBER");
					Thread.sleep(1000);
				}
				
			}catch(Exception e){
				System.out.println("TimeBasedTrafficLight error: "+e.getMessage());
			}
		}
		
		public void changeColorSimulator(String value)
		{
			ServiceReference reference = Activator.bc.getServiceReference(VenSend.class.getName());
			VenSend service = (VenSend)Activator.bc.getService(reference);
			ArrayList<Double> solution=new ArrayList<Double>();
			solution.add((Double)3.0);
			service.sendMessage("CVIS","CHANGE_"+value,solution);
		}
	}
}
