package com.ntnu.core;

import org.osgi.service.event.Event;
import org.osgi.service.event.EventHandler;

public class TrafficLightEventHandler implements EventHandler{
	private int trafficLightColor = 0;
	private Activator activator;
	
	public TrafficLightEventHandler(Activator activator)
	{
		this.activator = activator;
	}
	
	@Override
	public void handleEvent(Event eve) 
	{
		try
		{
			String[] propertyNames=eve.getPropertyNames();
			for(int i =0;i<propertyNames.length;i++)
			{
				if(propertyNames[i].contains("org/npra/ven/CVIS/CHANGE_GREEN/0"))
				{
					if(trafficLightColor == 1)
					{
						activator.calcAvgWaitingTime();
					}
					trafficLightColor = 2;
				}
				else if(propertyNames[i].contains("org/npra/ven/CVIS/CHANGE_AMBER/0"))
				{
					if(trafficLightColor == 2)
					{
						activator.clearIntention();
					}
					trafficLightColor = 1;
				}
				else if(propertyNames[i].contains("org/npra/ven/CVIS/CHANGE_RED/0"))
				{
					trafficLightColor = 0;
				}
			}
		}catch(Exception e){
			System.out.println("SendPedestrians event error: "+e.getMessage());
		}
	}
}
